

#include "WagnisProvince.h"
#include "core/CoreIncludes.h"
#include "BulletDynamics/Dynamics/btRigidBody.h"
#include "worldentities/StaticEntity.h"
#include <vector>

#define WAGNIS_PROVINCE_MAX_HEALTH 1000000.0f

/**TODO
 * 
 * 
 * 
 **/

namespace orxonox
{
    RegisterClass(WagnisProvince);

    //Constructor
    WagnisProvince::WagnisProvince(Context* context) : Pawn(context){
        RegisterObject(WagnisProvince);
        this->owner_ID = -1;
        this->troops = 0;
        this->ID = -1;
        this->continent = -1;
        this->neighbors = std::vector<WagnisProvince*>();
        this->markerBillboard = nullptr;
        
        this->initialHealth_ = WAGNIS_PROVINCE_MAX_HEALTH;
        this->maxHealth_ = WAGNIS_PROVINCE_MAX_HEALTH;
        this->health_ = WAGNIS_PROVINCE_MAX_HEALTH;
    }
    //Destructor
    WagnisProvince::~WagnisProvince(){

    }

    //XML Port
    void WagnisProvince::XMLPort(Element& xmlelement,XMLPort::Mode mode){
        SUPER(WagnisProvince, XMLPort, xmlelement, mode);

        XMLPortObject(WagnisProvince, Billboard, "MarkerBillboard", addMarkerBillboard, getMarkerBillboard, xmlelement, mode);
        XMLPortParam(WagnisProvince, "ID", setID, getID, xmlelement, mode);
        XMLPortParam(WagnisProvince, "continent", setContinent, getContinent, xmlelement, mode);
    }

    void WagnisProvince::addMarkerBillboard(Billboard* billi){
        this->markerBillboard = billi;
        attach(billi);
    }
    Billboard* WagnisProvince::getMarkerBillboard(unsigned int i) const{
        if(i != 0) return nullptr;
        return this->markerBillboard;
    }




    //SET()

    //set owner_ID
    void WagnisProvince::setOwner_ID(int owner){
        this->owner_ID = owner;
    }
    //set troops
    void WagnisProvince::setTroops(int troops){
        this->troops = troops;
    }
    //set ID
    void WagnisProvince::setID(int id){
        this->ID = id;
    }
    //set Continent
    void WagnisProvince::setContinent(int cont){
        this->continent = cont;
    }


    //GET()

    //get owner_ID
    int WagnisProvince::getOwner_ID() const{
        return this->owner_ID;
    }
    //get troops
    int WagnisProvince::getTroops() const{
        return this->troops;
    }
    //get ID
    int WagnisProvince::getID() const{
        return this->ID;
    }
    //get continent
    int WagnisProvince::getContinent() const{
        return this-> continent;
    }

    //Adds a connection to neighbors.
    void WagnisProvince::addNeighbor(WagnisProvince* prov){
        neighbors.push_back(prov);
    }

    void WagnisProvince::setBillbardVisibility(bool b){
        //TODO set visibility of billboard
    }
}
